/***********************
 * xdicom by Tony Voet *
 ***********************/

#include <stdlib.h>
#include "xdicom.h"

IMAGE *image;

int image_min,image_max;

static int images;

/**************
 * init image *
 **************/

void image_init(void)
{
  dicom_log(DEBUG,"image_init()");

  image=0L;
}

/****************
 * change image *
 ****************/

void image_change(char *file)
{
  U16 *u16,max;
  int i;

  dicom_log(DEBUG,"image_change()");

  image_free();
  zoom_free();
  wc_free();

  dicom_image(file,&image,&images);

  max=0;
  for (i=image[0].w*image[0].h,u16=image[0].data.gray; i; i--,u16++)
    if (*u16>max)
      max=*u16;

  printf("max is %u\n",max);

  image_min=0;
  image_max=0xFFFF;
}

/**************
 * free image *
 **************/

void image_free(void)
{
  dicom_log(DEBUG,"image_free()");

  dicom_free(image,images);
  image=0L;
}

/* test images

  static int	i=0;
  int		x,y;
  u_short	*d;

  dicom_log(DEBUG,"image_change()");

  image_free();
  zoom_free();
  wc_free();

  switch(i)
  {
  case 0 :
    * 256x256 16 bit flow *
    image->w=256;
    image->h=256;
    image->data.gray=xrad_malloc(image->w*image->h*sizeof(u_short));

    d=image->data.gray;
    for (y=0; y<image->h; y++)
      for (x=0; x<image->w; x++)
	*d++=x*y;
    break;
  case 1 :
    * 16x16 8 bit flow *
    image->w=16;
    image->h=16;
    image->data.gray=xrad_malloc(image->w*image->h*sizeof(u_short));

    d=image->data.gray;
    for (y=0; y<image->h; y++)
      for (x=0; x<image->w; x++)
	*d++=(image->w*y+x)<<8;
    break;
  case 2 :
    * 8x8 1 bit chessboard *
    image->w=8;
    image->h=8;
    image->data.gray=xrad_malloc(image->w*image->h*sizeof(u_short));

    d=image->data.gray;
    for (y=0; y<image->h; y++)
      for (x=0; x<image->w; x++)
	*d++=((x+y)&1)<<15;
    break;
  case 3 :
    * 32x16 12 bit chessboard *
    image->w=32;
    image->h=16;
    image->data.gray=xrad_malloc(image->w*image->h*sizeof(u_short));

    d=image->data.gray;
    for (y=0; y<image->h; y++)
      for (x=0; x<image->w; x++)
	*d++=16383*((x+y)&1);
    break;
  case 4 :
    * 4x8 2 bit chessboard *
    image->w=4;
    image->h=8;
    image->data.gray=xrad_malloc(image->w*image->h*sizeof(u_short));

    d=image->data.gray;
    for (y=0; y<image->h; y++)
      for (x=0; x<image->w; x++)
	*d++=((x+y)&3)<<14;
    break;
  }

  if (i==4)
    i=0;
  else
    i++;

  image_min=0;
  image_max=0xFFFF;
*/
