/******************************
 * dicom 2 ascii by Tony Voet *
 ******************************/

#include <stdio.h>
#include <stdlib.h>
#include <dicom.h>

/********
 * main *
 ********/

int main(int argc,char *argv[])
{
  IMAGE	*image;
  int	images,i,j;
  U16	width=80;

  if (argc<2)
  {
    fprintf(stderr,"%s (%s)\n",*argv,dicom_version);
    fprintf(stderr,"Usage: %s [-w width] dicom-file ...\n",*argv);
    fprintf(stderr,"   -w: width (default %d)\n",width);

    return -1;
  }

  dicom_log_name(*argv);

  for (i=1; i<argc; i++)
  {
    if (!strcmp(argv[i],"-w"))
    {
      if (i==argc-1)
      {
	dicom_log(ERROR,"No width specified");
	return -2;
      }

      width=atoi(argv[i+1]);
      i++;

      continue;
    }

    puts(argv[i]);
    puts("");

    if (dicom_read(argv[i],&image,&images,0))
      continue;

    for (j=0; j<images; j++)
    {
      dicom_write_ascii(0L,image+j,width);
      puts("");
    }

    dicom_free(image,images);
  }

  return 0;
}
