/*****************************
 * dicom 2 jpeg by Tony Voet *
 *****************************/

#include <stdio.h>
#include <stdlib.h>
#include <dicom.h>
#include <jpeglib.h>

/********
 * main *
 ********/

int main(int argc,char *argv[])
{
  IMAGE	*image;
  int	images,quality=75,i,j;

  if (argc<2)
  {
    fprintf(stderr,"%s (%s,libjpeg 6a)\n",*argv,dicom_version);
    fprintf(stderr,"Usage: %s [-q factor] dicom-file ...\n",*argv);
    fprintf(stderr,"   -q: quality factor (range 0..100,default %d)\n",quality);

    return -1;
  }

  dicom_log_name(*argv);

  for (i=1; i<argc; i++)
  {
    if (!strcmp(argv[i],"-q"))
    {
      if (i==argc-1)
      {
	dicom_log(ERROR,"No quality factor specified");
	return -2;
      }

      quality=atoi(argv[i+1]);
      i++;

      if (quality<0 || 100<quality)
      {
        dicom_log(ERROR,"Quality factor out of range 0..100");
        return -3;
      }
      continue;
    }

    if (dicom_read(argv[i],&image,&images,0))
      continue;

    for (j=0; j<images; j++)
      dicom_write_jpeg("out.jpg",image+j,quality);

    dicom_free(image,images);
  }

  return 0;
}
