/***********************
 * xdicom by Tony Voet *
 ***********************/

#include <stdlib.h>
#include <unistd.h>
#include "xdicom.h"

char	**directory=0L;
int	entries=0,current=-1;

/*****************
 * set directory *
 *****************/

int directory_set(const char *path,const char *file)
{
  FL_Dirlist	*list,*s;
  int		size,i;
  char		**d;

  dicom_log(INFO,"directory_set()");

  if (!path)
    return -1;

  if (chdir(path))
  {
    dicom_log(ERROR,"Unable to change directory");
    return -2;
  }

  directory_free();

  list=(FL_Dirlist*) fl_get_dirlist(".","*",&size,0);

  s=list;
  for (i=size; i; i--,s++)
    if (s->type==FT_FILE || s->type==FT_LINK)
      entries++;

  if (!entries)
  {
    fl_free_dirlist(list);
    return 0;
  }

  directory=malloc(entries*sizeof(char*));
  if (!directory)
    goto memory;

  s=list;
  d=directory;

  for (i=size; i; i--,s++)
    if (s->type==FT_FILE || s->type==FT_LINK)
    {
      *d=malloc(strlen(s->name)+1);
      if (!*d)
        goto memory;
      strcpy(*d++,s->name);
    }

  fl_free_dirlist(list);

  d=directory;
  for (i=0; i<entries; i++)
    if (!strcmp(*d++,file))
    {
      current=i;
      break;
    }

  if (current<0)
  {
    dicom_log(ERROR,"File not found");

    directory_free();
    slider_clear();

    return -3;
  }

  return 0;

memory:
  dicom_log(ERROR,"Out of memory");

  fl_free_dirlist(list);
  directory_free();

  return -4;
}

/******************
 * free directory *
 ******************/

void directory_free(void)
{
  int	i;
  char	**d;

  dicom_log(INFO,"directory_free()");

  if (directory)
  {
    d=directory;
    for (i=entries; i; i--)
      free(*d++);

    free(directory);
    directory=0L;
  }

  entries=0;
  current=-1;
}
