/***********************
 * xdicom by Tony Voet *
 ***********************/

#include "xdicom.h"

static void	xdicom_init(int *,char **);
static int	xdicom_close(FL_FORM *,void *);

FD_main *form_main;

/********
 * main *
 ********/

int main(int argc,char *argv[])
{
  dicom_log_name(*argv);
  dicom_log(NOTICE,"Welcome to Xdicom");
  dicom_log_level=INFO;

  xdicom_init(&argc,argv);

  menu_init();
  slider_clear();

  fl_show_form(form_main->main,FL_PLACE_ASPECT,FL_FULLBORDER,"Xdicom");

  canvas_init();

  fl_do_forms();

  return 0;
}

/***************
 * free xdicom *
 ***************/

void xdicom_free(void)
{
  dicom_log(INFO,"xdicom_free()");

  menu_free();
  directory_free();
  slider_free();

  canvas_free();
  colormap_free();

  fl_end_all_command();
}

/***************
 * init xdicom *
 ***************/

static void xdicom_init(int *argc,char *argv[])
{
  dicom_log(INFO,"xdicom_init()");

  fl_initialize(argc,argv,"Xdicom",0,0);

  fl_set_border_width(-2);
  fl_set_fselector_fontsize(FL_MEDIUM_FONT);
  fl_set_goodies_font(FL_NORMAL_STYLE,FL_MEDIUM_FONT);

  fl_set_atclose(xdicom_close,0L);

  form_main=create_form_main();
}

/****************
 * close xdicom *
 ****************/

static int xdicom_close(FL_FORM *form,void *data)
{
  dicom_log(INFO,"xdicom_close()");

  if (form==form_main->main)
  {
    xdicom_free();
    return FL_OK;
  }

  fl_hide_form(form);
  return FL_IGNORE;
}
