/***********************
 * xdicom by Tony Voet *
 ***********************/

#ifndef __XDICOM__

#include <forms.h>
#include <dicom.h>
#include "design.h"

/**********
 * canvas *
 **********/

extern Display	*display;
extern Visual	*visual;
extern Window	window;

void canvas_init(void);
int canvas_update(void);
void canvas_free(void);

void canvas_clear(int,int);
int canvas_expose(int,int);

/************
 * colormap *
 ************/

extern XColor	*color;
extern int	colors,rwcolor;

int colormap_init(void);
void colormap_change(void);
void colormap_reset(void);
void colormap_free(void);

extern int image_min,image_max;

/******
 * wc *
 ******/

extern XImage *wc;

void wc_init(void);
int wc_change(void);
void wc_free(void);

void wc_start(int,int);
void wc_set(int,int,int,int);
void wc_end(int,int,int);

extern IMAGE *zoom;

/* rewritten */

/**********
 * xdicom *
 **********/

extern FD_main *form_main;

void xdicom_free(void);

/********
 * menu *
 ********/

void menu_init(void);
void menu_free(void);

void menu_resize(int,int);

/*************
 * directory *
 *************/

extern char	**directory;
extern int	entries,current;

int	directory_set(const char *,const char *);
void	directory_free(void);

/**********
 * slider *
 **********/

extern IMAGE	*image;
extern int	frame;

void	slider_clear(void);
int	slider_open(int);
void	slider_free(void);

#define __XDICOM__
#endif
